local scroll_speed = 1.5
local active_scroll = {}

-- Aktivierung
local function set_scroll(player_index, direction, is_pressed)
  if not active_scroll[player_index] then
    active_scroll[player_index] = {}
  end
  active_scroll[player_index][direction] = is_pressed
end

-- Input-Tasten-Events
local directions = { "up", "down", "left", "right" }

for _, dir in pairs(directions) do
  local name = "fast-scroll-" .. dir
  script.on_event(name, function(event)
    set_scroll(event.player_index, dir, true)
  end)
  script.on_event(name .. "-release", function(event)
    set_scroll(event.player_index, dir, false)
  end)
end

-- Kontinuierliches Scrollen
script.on_event(defines.events.on_tick, function()
  for player_index, scroll in pairs(active_scroll) do
    local player = game.get_player(player_index)
    if player and player.valid and player.controller_type == defines.controllers.god then
      local dx, dy = 0, 0
      if scroll.up then dy = dy - scroll_speed end
      if scroll.down then dy = dy + scroll_speed end
      if scroll.left then dx = dx - scroll_speed end
      if scroll.right then dx = dx + scroll_speed end

      if dx ~= 0 or dy ~= 0 then
        local pos = player.position
        player.teleport({pos.x + dx, pos.y + dy})
      end
    end
  end
end)